/****************************************************************************

 MESSAGE PASSING INTERFACE TEST CASE SUITE

 Copyright IBM Corp. 1995

 IBM Corp. hereby grants a non-exclusive license to use, copy, modify, and
 distribute this software for any purpose and without fee provided that the
 above copyright notice and the following paragraphs appear in all copies.

 IBM Corp. makes no representation that the test cases comprising this
 suite are correct or are an accurate representation of any standard.

 In no event shall IBM be liable to any party for direct, indirect, special
 incidental, or consequential damage arising out of the use of this software
 even if IBM Corp. has been advised of the possibility of such damage.

 IBM CORP. SPECIFICALLY DISCLAIMS ANY WARRANTIES INCLUDING, BUT NOT LIMITED
 TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
 PURPOSE.  THE SOFTWARE PROVIDED HEREUNDER IS ON AN "AS IS" BASIS AND IBM
 CORP. HAS NO OBLIGATION TO PROVIDE MAINTENANCE, SUPPORT, UPDATES,
 ENHANCEMENTS, OR MODIFICATIONS.

****************************************************************************

 These test cases reflect an interpretation of the MPI Standard.  They are
 are, in most cases, unit tests of specific MPI behaviors.  If a user of any
 test case from this set believes that the MPI Standard requires behavior
 different than that implied by the test case we would appreciate feedback.

 Comments may be sent to:
    Richard Treumann
    treumann@kgn.ibm.com

****************************************************************************

 MPI-Java version :
    Sung-Hoon Ko(shko@npac.syr.edu)
    Northeast Parallel Architectures Center at Syracuse University
    09/01/99

****************************************************************************/

import mpi.*;
//import java.io.*;

//typedef struct {
//   int data;
//   int flag;
//} mydt;

/*
  void less(in,inout,count,dt)
  mydt *in,*inout;
int *count;
MPI_Datatype *dt;
{
int i;

if(*dt != MPI_2INT)  printf("ERROR in less: wrong data type\n");

for(i=0;i<*count;i++)
inout[i].flag = (in[i].data < inout[i].data) && in[i].flag && inout[i].flag;
}
*/
/*
  class Mydt {
  int data;
  int flag;
  }
*/

class Less extends User_function {
  public void Call (Object invec, int inoffset, Object outvec, int outoffset, int count, Datatype datatype) 
  {
    //int me1 = MPI.COMM_WORLD.Rank();    
    //System.out.println("outoffset="+outoffset+",in="+inoffset+",count="+count+"\n");
    int [] in_array = (int[])invec;
    int [] out_array = (int[])outvec;

    if(datatype != MPI.INT2) 
      System.out.println("ERROR in less: wrong data type");
    
    //for(int i=0;i<count;i++) {
    //int base = 2*i;
      //int in = out_array[outoffset + i];
      //int inout = in_array[inoffset + i];
      int indata = in_array[0];
      int inflag = in_array[1];
      int inoutdata = out_array[0];
      int inoutflag = out_array[1];
System.out.println("indata="+indata+",inflag="+inflag+",inoutdata="+inoutdata+", inoutflag="+inoutflag+"\n");
      //inout.flag = (in.data < inout.data) && in.flag && inout.flag;
      
      if((indata < inoutdata) && inflag==1 && inoutflag==1)
	inoutflag=1;
      else
	inoutflag=0;
      
    //} 
  }
}



class op1 {
  static public void main(String[] args) throws MPIException {
    
	
    int me,tasks,i,root,rc;
    //Mydt info[] = new Mydt[1];
    //Mydt result[] = new Mydt[1]; 
    int info[] = new int[2];
    int result[] = new int[2];
	
    //Op temp;
    //Op op;
    boolean bool = false;

    MPI.Init(args);
    me = MPI.COMM_WORLD.Rank();
    tasks = MPI.COMM_WORLD.Size();

    //commute = 0;
    //MPI_Op_create(less,commute,&op);
    Less less = new Less();

    Op op = new Op(less,bool); 
	
    //Op temp = new Op(less,bool); 

    //result[0] = new Mydt(); 
    //info[0] = new Mydt();  
    //info[0].data = me;
    //info[0].flag = 1;
    info[0] = me;
    info[1] = 1 ;

    /*

    root = 0;
    //MPI_Reduce(&info,&result,1,MPI_2INT,op,root,MPI_COMM_WORLD);
    MPI.COMM_WORLD.Reduce(info,0,result,0,2,MPI.INT2,op,root);


    if(me == root)
      if(result[1] != 1)
	System.out.println("ERROR in MPI_Reduce(1): result = "+result[1]+", should be 1");
    

    root = tasks/2;
    //MPI_Reduce(&info,&result,1,MPI_2INT,op,root,MPI_COMM_WORLD);
    MPI.COMM_WORLD.Reduce(info,0,result,0,2,MPI.INT2,op,root);
    if(me == root)
      if(result[1] != 1)
	System.out.println("ERROR in MPI_Reduce(2): result = "+result[1]+", should be 1");
	*/

    info[0] = tasks - me;
    root = tasks-1;
    //MPI_Reduce(&info,&result,1,MPI_2INT,op,root,MPI_COMM_WORLD);
    MPI.COMM_WORLD.Reduce(info,0,result,0,2,MPI.INT2,op,root);
    if(me == root)
      if(result[1] != 0)
	System.out.println("ERROR in MPI_Reduce(3): result = "+result[1]+", should be 0");

    /*
      info[0].data = me;
      if(me == 0)  info[0].data = 1;
      //MPI_Reduce(&info,&result,1,MPI_2INT,op,root,MPI_COMM_WORLD);
      MPI.COMM_WORLD.Reduce(info,0,result,0,1,MPI.INT2,op,root);
      if(me == root)
      if(result[0].flag != 0)
      System.out.println("ERROR in MPI_Reduce(4): result = "+result[0].flag+", should be 1");
    */
    /*
      temp = op;
      //MPI_Op_free(&op);
      op.finalize();
      if(op != MPI_OP_NULL)
      printf("ERROR in MPI_Op_free: op not set to NULL\n");

      MPI_Errhandler_set(MPI_COMM_WORLD,MPI_ERRORS_RETURN);
      rc = MPI_Reduce(&info,&result,1,MPI_2INT,op,root,MPI_COMM_WORLD);
      MPI_Error_class(rc,&class);
      if(class != MPI_ERR_OP) {
      printf("WARNING in MPI_Op_free: error on NULL op not MPI_ERR_OP\n"); 
      printf("error returned was %d(%d)\n", rc, class );
      }
      op = temp;
      rc = MPI_Reduce(&info,&result,1,MPI_2INT,op,root,MPI_COMM_WORLD);
      MPI_Error_class(rc,&class);
      if(class != MPI_ERR_OP) {
      printf("WARNING in MPI_Op_free: error on op not freed not MPI_ERR_OP\n"); 
      printf("error returned was %d(%d)\n", rc, class );
      }

      op = MPI_OP_NULL;
      MPI_Op_create(less,commute,&op);
      // This is NOT an error 
      //
      //if(op != temp)
      //printf("ERROR in MPI_Op_create: op not reused\n");
      //
      op = MPI_SUM;
      rc = MPI_Op_free(&op);
      MPI_Error_class(rc,&class);
      if(class != MPI_ERR_OP) {
      char errmsg[MPI_MAX_ERROR_STRING];
      int  rlen;
      printf("WARNING in MPI_Op_free: error on free MPI_SUM not MPI_ERR_OP\n"); 
      MPI_Error_string( rc, errmsg, &rlen );
      printf("error returned was %s [%d(%d)]\n", errmsg, rc, class );
      }
    */

    MPI.COMM_WORLD.Barrier();
    if(me == 0)  System.out.println("Op TEST COMPLETE\n");
    MPI.Finalize();
  }
}




